/*;  khrbtree.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl khrbtree.h\quad\thepage}} */
/*;  $$Date: 1997/09/14 09:56:21 $$  */
/*;  $$Source: /home/shiiba/KhC++LibDevelop/trees/khrbtree.h,v $$  */

/*
ΥץϡScott Robert Ladd ˤ C++ Templates and Tools
˷ǺܤƤץ򸵤ˤƤޤ

Υץϡ㳰(try, throw, catch ʤɤȤ)Υɤ
Ǥޤassertޥˤ֤Ƥޤ
*/

//=============================================================
//  KhBinary Tree Classes     rbtree.h    v3.00
//      Template for red-black binary tree types
//      Copyright 1995 Scott Robert Ladd
//=============================================================

#ifndef khrbtree_h
#define khrbtree_h

#include <stddef.h>
#include "khbintree.h"
#include "khboolean.h"

//-------------------------------------------------------------
//  internal data types used by a red-black binary tree
//-------------------------------------------------------------

enum RBColor { BLACK, RED };

template <class D>
struct KhRBData
{
  RBColor Color;
  D       RealData;

  KhRBData()
    : RealData()
  {
    Color = BLACK;
  }

  KhRBData
  (
   const D & item
   )
  {
    RealData = item;
    Color = BLACK;
  }

  int operator <
  (
   const KhRBData & rbd
   )
       const
  {
    return (RealData < rbd.RealData);
  }

  int operator >
  (
   const KhRBData & rhd
   )
       const
  {
//    return (RealData > rbd.RealData);
    return (rhd.RealData < RealData);
  }

  int operator ==
  (
   const KhRBData & rbd
   )
       const
  {
    return (RealData == rbd.RealData);
  }

  int operator !=
  (
   const KhRBData & rbd
   )
       const
  {
    return (RealData == rbd.RealData);
  }
};

//-------------------------------------------------------------
//  RedBlackTree
//      A red-black binary tree
//-------------------------------------------------------------

template <class D>
class KhRedBlackTree : public KhBinaryTree< KhRBData<D> >
{
 public:
  // constructor
  KhRedBlackTree();

  KhRedBlackTree
  (
   const KhRedBlackTree<D> & tree
   );

  // assignment operator
  void operator =
  (
   const KhRedBlackTree<D> & tree
   );

  // store an item
  void Insert
  (
   const D & item
   );

  // delete an item
  KhBoolean Delete
  (
   const D & item
   );

  // retrieve an item
  // If a data equivalent to the argument "item" has been
  // stored in the tree already, GetPtrToData returns the pointer to
  // the data. Otherwise, GetPtrToData returns NULL.
  D * GetPtrToData(const D & item);

 protected:
  // tree adjustment utilities
  void RotateLeft
  (
   KhTreeNode< KhRBData<D> > * node
   );

  void RotateRight
  (
   KhTreeNode< KhRBData<D> > * node
   );

  void DeleteFixup
  (
   KhTreeNode< KhRBData<D> > * node
   );
};

template <class D>
inline KhRedBlackTree<D>::KhRedBlackTree()
: KhBinaryTree< KhRBData<D> >()
{
  // placeholder
}

template <class D>
inline KhRedBlackTree<D>::KhRedBlackTree
(
 const KhRedBlackTree<D> & tree
)
  : KhBinaryTree< KhRBData<D> >(tree)
{
  // placeholder
}

//---------------------------
// binary tree iterator class
//---------------------------

template <class D>
class KhRBTreeIterator : public KhBinaryTreeIterator< KhRBData<D> >
{
 public:
  KhRBTreeIterator
  (
   KhRedBlackTree<D> & bt
   );

  KhRBTreeIterator
  (
   KhRBTreeIterator<D> & iter
   );

  void operator =
  (
   KhRBTreeIterator<D> & iter
   );

  D operator * ();
  operator D*();

};

#endif

/*; end of file */
