/*;  ohymos.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl ohymos.cc\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#)

/*
{\ {\setlength{\parskip}{4pt}% latex-mode
...
}% end of latex-mode }
*/

#include <stdio.h>
#include <time.h>
#include "p_tmp.h"
#include "scftotal.h"
#include "time.h"

#include <string.h> /* strlen,strchr */
#ifdef __MSDOS__
#include "sjis.h" /* եJISʸȽؿ */
#endif

char *nopath( /* ե̾Фؿ NO PATH */
/* ե̾ */
char *aFn) /* ѥ̾ޤե̾ File Name */
{
#ifndef __MSDOS__
  char *p=strrchr(aFn, '/');
  if (p!=NULL) return p+1;
  return aFn;
#else
  int i;
  for (i=strlen(aFn)-1;i>0;i--)
  if(aFn[i]=='\\' && sjis(aFn,i)!=1)return (char *)aFn+1+i;
  return (char*)aFn;
#endif
} /* npath */

void
cat_filename(	    //; ե̾δʬȳĥҤι
  char* aBasepart,  //; ե̾δʬ (. "foo")
  char* aExtension, //; ե̾γĥʬ (. ".doc")
  char* aFilename   //; ե̾Ǽ (. "foo.doc")
  //
  //; ե̾ǼΰϡƤӽФץ
  //; Ǥ餫ݤƤʤФʤޤ
  //
)
{
  aFilename[0] = '\0';
  strcpy(aFilename, aBasepart);
  strcat(aFilename, aExtension);
}

char* version = "version 0.1";

void usage(char *command)
{
  cerr << "ohymos " << version << " copyright KyotoHydro" << endl;

  cerr << "usage: " << command << " [-h] scffile fileBasePart" << endl;
  cerr << "\n"
       << "  scffile:       file name of a Structure Configuration File \n"
       << "  fileBasePart:  common base part of the following file names.\n"
       << "\n"
       << "    [input]\n"
       << "    parameter file        `fileBasePart'.pmt \n"
       << "    initial state file    `fileBasePart'.ist \n"
       << "    port data file        `fileBasePart'.isd \n"
       << "    Note. When your simulation starts from full-scratch "
       << " `fileBasePart'.isd \n"
       << "    should not exist.\n"
       << "    [output]\n"
       << "    terminal state file   `fileBasePart'.tst \n"
       << "    port data file        `fileBasePart'.tsd \n"
       << "\n"
       << "  You can continue the simulation by replacing\n"
       << "    `fileBasePart'.ist with `fileBasePart'.tst\n"
       << "    `fileBasePart'.isd with `fileBasePart'.tsd\n"
       << "\n" << endl;
  exit(1);
}

//; ᥤץ

int main(int argc, char** argv)
{

  // ׻ַ¬
  clock_t start, finish;
  long duration;

  char* command = argv[0];
  while (argc > 1 && argv[1][0] == '-') {
    if (strcmp(argv[1], "-h") == 0) {
      usage(command);
    }
    else {
      // illegal option
      usage(command);
    }
  }

  if (argc != 3) {
    usage(nopath(argv[0]));
  }

  char file_basepart[FILENAME_MAX];
  ScfTotalSystem total_system(argv[1]);
  strcpy(file_basepart, argv[2]);

  //; 鲼ѹɬפϤ̵֤Ǥ礦

  // total_system.Set_ohymos_option(); // simulation option 

  if (total_system.Construct() != YES)
  { printf("\n# Failure : Construct.\n"); return 1; }

  if (total_system.Switch() != YES)
  { printf("\n# Failure : Switch.\n"); return 1; }

  if (total_system.Are_you_ready() != YES)
  { printf("\n# Failure : Are_you_ready.\n"); return 1; }

  //; ѥ᥿ե뤫ɤߤȤ
  char wfilename[FILENAME_MAX];
  cat_filename(file_basepart, ".pmt", wfilename);
  total_system.Read_parameter_file(wfilename);

  //; ֤ե뤫ɤߤȤ
  cat_filename(file_basepart, ".ist", wfilename);
  total_system.Read_initial_state_file(wfilename);

  //; üҥǡꥹȥ
  cat_filename(file_basepart, ".isd", wfilename);
  // If $(file_basepart).isd does not exist, nothig will be
  // done by the folloing function.
  total_system.Read_send_port_file(wfilename);

  total_system.Do_share_info();

  //; ׻ַ¬
  start = clock();

  total_system.Initial_work();
  total_system.Work();

  //; ׻ַ¬λ
  finish = clock();
  duration = (finish - start) / CLOCKS_PER_SEC / 60;
  printf("Duration for calculation (min) : %ld\n", duration);

  //; ǽ֤ե¸
  cat_filename(file_basepart, ".tst", wfilename);
  total_system.Write_terminal_state(wfilename);

  //; üҤ˻ĤäƤǡե¸
  cat_filename(file_basepart, ".tsd", wfilename);
  total_system.Write_send_port_stock(wfilename);
  return 0;
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
