// tksedge.cc

#include <stdio.h>
#include <time.h>

#include "total.h"				// class Total_system 
#include "p_tmp.h"
#include "ksedge.h"				// class KsEdge 
#include "adder.h"				// class Adder 
#include "kinem.h"				// class Kinem 

// 饹 VirtualRiverBasin 

class VirtualRiverBasin : public Total_system
{

  protected:

	// ü
	I_file<double> ip1;		  // ߿嶯 (mm/hour)
	I_file<double> ip2;		  // ߿嶯 (mm/hour)

	// üҤϿ
	void Register_input_ports(void)
 	{
 		Register((void*) &ip1);
 		Register((void*) &ip2);
	}
	
  protected:

	// ü
	O_file<double> op;
	O_file<double> opSarea;
	O_file<double> opStorage;

	// üҤϿ
	void Register_output_ports(void)
	{
		Register((void*) &op);
		Register((void*) &opSarea);
		Register((void*) &opStorage);
	}
		
  protected:
	// 
	KsEdge ksedges1;
	KsEdge ksedges2;
	Adder add1;
	Adder add2;
	Adder add3;
	Kinem kinem1;
	Kinem kinem2;

	// ǤϿ
	void Register_components(void);

	// Ǵȿ׻ѤδؿʤΤǡȤʤ
	void Register_iterators(void) {}

  protected:
	// üҤ³
	void Connect_ports(void);

	// ľ̿ѤδؿʤΤǡȤʤ
	void Connect_components(void) {}

  public:
	// ֤
	virtual void Set_initial_state(FILE* fp)
	{
		fscanf(fp, "%ld", &current_time);
	}

  public:
	// 󥹥ȥ饯
	VirtualRiverBasin(void);

};

// ǤϿ
void VirtualRiverBasin::Register_components(void)
{
	Register((void*) &ksedges1);
	Register((void*) &ksedges2);
//	Register((void*) &add1);
	Register((void*) &add2);
	Register((void*) &add3);
	Register((void*) &kinem1);
	Register((void*) &kinem2);
}

// üҤ³
void VirtualRiverBasin::Connect_ports(void)
{
	Connect(((void*) &ip1), ((void*) &ksedges1), "Receive", "rp", 0);
	Connect(((void*) &ip2), ((void*) &ksedges2), "Receive", "rp", 0);
//	Connect(((void*) &ksedges1), "Send", "sp", 0, ((void*) &add1), "Receive", "rp", 0);
	Connect(((void*) &ksedges1), "Send", "spSarea", 0, ((void*) &add2), "Receive", "rp", 0);
	Connect(((void*) &ksedges1), "Send", "spStorage", 0, ((void*) &add3), "Receive", "rp", 0);
//	Connect(((void*) &ksedges2), "Send", "sp", 0, ((void*) &add1), "Receive", "rp", 1);
	Connect(((void*) &ksedges2), "Send", "spSarea", 0, ((void*) &add2), "Receive", "rp", 1);
	Connect(((void*) &ksedges2), "Send", "spStorage", 0, ((void*) &add3), "Receive", "rp", 1);
//	Connect(((void*) &add1), "Send", "sp", 0, ((void*) &op));
	Connect(((void*) &add2), "Send", "sp", 0, ((void*) &opSarea));
	Connect(((void*) &add3), "Send", "sp", 0, ((void*) &opStorage));
//
	Connect(((void*) &ksedges1), "Send", "sp", 0, ((void*) &kinem1), "Receive", "rpl", 0);
	Connect(((void*) &ksedges2), "Send", "sp", 0, ((void*) &kinem2), "Receive", "rpl", 0);
//
//	Connect(((void*) &kinem1), "Send", "sp", 0, ((void*) &add1), "Receive", "rp", 0);
//	Connect(((void*) &kinem2), "Send", "sp", 0, ((void*) &add1), "Receive", "rp", 1);

	Connect(((void*) &kinem1), "Send", "sp", 0, ((void*) &op));
	Connect(((void*) &kinem2), "Send", "sp", 0, ((void*) &kinem1), "Receive", "rpu", 0);
}

// 󥹥ȥ饯
VirtualRiverBasin::VirtualRiverBasin(void)
	:	Total_system(),
		ip1("tksedge.in"),
		ip2("tksedge.in2"),
		op("tksedge.out"),
		opSarea("tksedge.sat"),
		opStorage("tksedge.stg"),
		ksedges1("ksedges1", 0),
		ksedges2("ksedges2", 0),
//		add1("add1", 0, 2),
		add2("add2", 0, 2),
		add3("add3", 0, 2),
		kinem1("kinem1", 0, 1, 1),
		kinem2("kinem2", 0, 0, 1)
{
	class_name = "VirtualRiverBasin";

	// ηϥ饹 
	// ("֥̾", "ֹ֥", "ȿ׻롼פο")
	Init("vrb", 0, 0);
}

// ᥤץ

int main(void)
{
    VirtualRiverBasin vrb;		// ηϥǥ

	if (vrb.Construct() != YES)
		{ printf("\n# Failure : Construct.\n"); return 1; }

	if (vrb.Switch() != YES)
		{ printf("\n# Failure : Switch.\n"); return 1; }
	
	if (vrb.Are_you_ready() != YES)
		{ printf("\n# Failure : Are_you_ready.\n"); return 1; }
	
	// ѥ᥿ե뤫ɤߤȤ
	vrb.Read_parameter_file("tksedge.pmt");

	// ֤ե뤫ɤߤȤ
	vrb.Read_initial_state_file("tksedge.ist");

	// üҥǡꥹȥ
	vrb.Read_send_port_file("tksedge.isd");
	
	vrb.Initial_work();
	vrb.Work();
	
	// ǽ֤ե¸
	vrb.Write_terminal_state("tksedge.tst");

	// üҤ˻ĤäƤǡե¸
	vrb.Write_send_port_stock("tksedge.tsd");
	return 0;
}
