// tksedgefc2d.cc

#include <stdio.h>
#include <time.h>

// modified by iYutaka (Sun Feb 18 13:13:28 2001)
// This file has to be included before p_tmp.h.
#include "ksedgefc2d.h"				// class KsEdgeFc2d 

//#include "/home/tatikawa/ohymos-lib/ohymos-3.0d/htmls/total.h"				// class Total_system 
//#include "/home/tatikawa/ohymos-lib/ohymos-3.0d/htmls/p_tmp.h"

#include "total.h"				// class Total_system 
#include "p_tmp.h"
#include "i_file_matrix.h"

// 饹 VirtualRiverBasin 

class VirtualRiverBasin : public Total_system
{

  protected:

	// ü
//	I_file<double> ip;		  // ߿嶯 (mm/hour)
	I_file_matrix<KhDMatrix> ip; // ߿嶯 (mm/hr)

	// üҤϿ
	void Register_input_ports(void)
 	{
 		Register((void*) &ip);
	}
	
  protected:

	// ü
	O_file<double> op;
	O_file<double> opSarea;
	O_file<double> opStorage;

	// üҤϿ
	void Register_output_ports(void)
	{
		Register((void*) &op);
		Register((void*) &opSarea);
		Register((void*) &opStorage);
	}
		
  protected:
	// 
	KsEdgeFc2d ksedgefc2d;

	// ǤϿ
	void Register_components(void);

	// Ǵȿ׻ѤδؿʤΤǡȤʤ
	void Register_iterators(void) {}

  protected:
	// üҤ³
	void Connect_ports(void);

	// ľ̿ѤδؿʤΤǡȤʤ
	void Connect_components(void) {}

  public:
	// ֤
	virtual void Set_initial_state(FILE* fp)
	{
		fscanf(fp, "%ld", &current_time);
	}

  public:
	// 󥹥ȥ饯
	VirtualRiverBasin(void);

};

// ǤϿ
void VirtualRiverBasin::Register_components(void)
{
	Register((void*) &ksedgefc2d);
}

// üҤ³
void VirtualRiverBasin::Connect_ports(void)
{
//	Connect(((void*) &ip), ((void*) &ksedgefc2d), "Receive", "rp", 0);
	Connect(((void*) &ip), ((void*) &ksedgefc2d), "ReceiveNointp", "rp", 0);
	Connect(((void*) &ksedgefc2d), "Send", "sp", 0, ((void*) &op));
	Connect(((void*) &ksedgefc2d), "Send", "spSarea", 0, ((void*) &opSarea));
	Connect(((void*) &ksedgefc2d), "Send", "spStorage", 0, ((void*) &opStorage));
}

// 󥹥ȥ饯
VirtualRiverBasin::VirtualRiverBasin(void)
	:	Total_system(),
		ip("tksedgefc2d.in"),
		op("tksedgefc2d.out"),
		opSarea("tksedgefc2d.sat"),
		opStorage("tksedgefc2d.stg"),
		ksedgefc2d("ksedgefc2d", 0)
{
	class_name = "VirtualRiverBasin";

	// ηϥ饹 
	// ("֥̾", "ֹ֥", "ȿ׻롼פο")
	Init("vrb", 0, 0);
}

// ᥤץ

int main(void)
{
    VirtualRiverBasin vrb;		// ηϥǥ

	if (vrb.Construct() != YES)
		{ printf("\n# Failure : Construct.\n"); return 1; }

	if (vrb.Switch() != YES)
		{ printf("\n# Failure : Switch.\n"); return 1; }
	
	if (vrb.Are_you_ready() != YES)
		{ printf("\n# Failure : Are_you_ready.\n"); return 1; }
	
	// ѥ᥿ե뤫ɤߤȤ
	vrb.Read_parameter_file("tksedgefc2d.pmt");

	// ֤ե뤫ɤߤȤ
	vrb.Read_initial_state_file("tksedgefc2d.ist");

	// üҥǡꥹȥ
	vrb.Read_send_port_file("tksedgefc2d.isd");
	
	vrb.Initial_work();
	vrb.Work();
	
	// ǽ֤ե¸
	vrb.Write_terminal_state("tksedgefc2d.tst");

	// üҤ˻ĤäƤǡե¸
	vrb.Write_send_port_stock("tksedgefc2d.tsd");
	return 0;
}
