// tksedgefc2devp.cc

#include <stdio.h>
#include <time.h>

// modified by iYutaka (Sun Feb 18 13:13:28 2001)
// This file has to be included before p_tmp.h.
#include "ksedgefc2devp-1.h"				// class KsEdgeFc2dEvp ̒`
#include "total.h"				// class Total_system ̒`
#include "p_tmp.h"
#include "i_file_matrix.h"

// NX VirtualRiverBasin ̒`

class VirtualRiverBasin : public Total_system
{
  
protected:
  
  // ͒[q
  I_file_matrix<KhDMatrix> ip; // ~x (mm/hr)
  I_file_matrix<KhDMatrix> ievp; // PʎԂ̊U (mm/hr)
  
  // ͒[q̓o^
  void Register_input_ports(void)
  {
    Register((void*) &ip);
    Register((void*) &ievp);
  }
  
protected:
  
  // o͒[q
  O_file<double> op;
  O_file<double> opSarea;
  O_file<double> opStorage;
  O_file<double> opEvp;
  
  // o͒[q̓o^
  void Register_output_ports(void)
  {
    Register((void*) &op);
    Register((void*) &opSarea);
    Register((void*) &opStorage);
    Register((void*) &opEvp);
  }
  
protected:
  // \vf
  KsEdgeFc2dEvp ksedgefc2devp;
  
  // \vf̓o^
  void Register_components(void);
  
  // vfԔvZp̊֐Ȃ̂ŁAgȂ
  void Register_iterators(void) {}
  
protected:
  // [q̐ڑ
  void Connect_ports(void);
  
  // ڒʐMp̊֐Ȃ̂ŁAgȂ
  void Connect_components(void) {}
  
public:
  // Ԃ̐ݒ
  virtual void Set_initial_state(FILE* fp)
  {
    fscanf(fp, "%ld", &current_time);
  }
  
public:
  // RXgN^
  VirtualRiverBasin(void);
  
};

// \vf̓o^
void VirtualRiverBasin::Register_components(void)
{
  Register((void*) &ksedgefc2devp);
}

// [q̐ڑ
void VirtualRiverBasin::Connect_ports(void)
{
  Connect(((void*) &ip), ((void*) &ksedgefc2devp), "ReceiveNointp", "rp", 0);
  Connect(((void*) &ievp), ((void*) &ksedgefc2devp), "ReceiveNointp", "evp", 0);
  Connect(((void*) &ksedgefc2devp), "Send", "sp", 0, ((void*) &op));
  Connect(((void*) &ksedgefc2devp), "Send", "spSarea", 0, ((void*) &opSarea));
  Connect(((void*) &ksedgefc2devp), "Send", "spStorage", 0, ((void*) &opStorage));
  Connect(((void*) &ksedgefc2devp), "Send", "spEvp", 0, ((void*) &opEvp));
}

// RXgN^
VirtualRiverBasin::VirtualRiverBasin(void)
  :	Total_system(),
	ip("./sample/radarRain4_ave.rain"),
	ievp("./sample/distEvp_11.data"),
	op("./sample/tksedgefc2devp.out"),
	opSarea("./sample/tksedgefc2devp.sat"),
	opStorage("./sample/tksedgefc2devp.stg"),
	opEvp("./sample/tksedgefc2devp.evp"),
	ksedgefc2devp("ksedgefc2devp", 0)
{
  class_name = "VirtualRiverBasin";
  
  // ŠnNX 
  // ("IuWFNg", "IuWFNgԍ", "vZO[v̐")
  Init("vrb", 0, 0);
}

// CvO

int main(void)
{
  VirtualRiverBasin vrb;		// Šnf
  
  if (vrb.Construct() != YES)
    { printf("\n# Failure : Construct.\n"); return 1; }
  
  if (vrb.Switch() != YES)
    { printf("\n# Failure : Switch.\n"); return 1; }
  
  if (vrb.Are_you_ready() != YES)
    { printf("\n# Failure : Are_you_ready.\n"); return 1; }
  
  // p^t@Cǂ݂Ƃ
  vrb.Read_parameter_file("./tksedgefc2devp.pmt");
  
  // Ԃt@Cǂ݂Ƃ
  vrb.Read_initial_state_file("./tksedgefc2devp.ist");
  
  // M[qf[^XgA
  vrb.Read_send_port_file("./tksedgefc2devp.isd");
  
  vrb.Initial_work();
  vrb.Work();
  
  // ŏIԂt@Cɕۑ
  vrb.Write_terminal_state("./tksedgefc2devp.tst");
  
  // M[qɎcĂf[^t@Cɕۑ
  vrb.Write_send_port_stock("./tksedgefc2devp.tsd");
  return 0;
}
